poj 1180 dp的斜率優化
http://poj.org/problem?id=1180
Description
There is a sequence of N jobs to be processed on one machine. The jobs are numbered from 1 to N, so that the sequence is 1,2,..., N. The sequence of jobs must be partitioned into one or more batches, where each batch consists of consecutive jobs in the sequence.
The processing starts at time 0. The batches are handled one by one starting from the first batch as follows. If a batch b contains jobs with smaller numbers than batch c, then batch b is handled before batch c. The jobs in a batch are processed successively
on the machine. Immediately after all the jobs in a batch are processed, the machine outputs the results of all the jobs in that batch. The output time of a job j is the time when the batch containing j finishes.
A setup time S is needed to set up the machine for each batch. For each job i, we know its cost factor Fi and the time Ti required to process it. If a batch contains the jobs x, x+1,... , x+k, and starts at time t, then the output time of every job in that batch is t + S + (Tx + Tx+1 + ... + Tx+k). Note that the machine outputs the results of all jobs in a batch at the same time. If the output time of job i is Oi, its cost is Oi * Fi. For example, assume that there are 5 jobs, the setup time S = 1, (T1, T2, T3, T4, T5) = (1, 3, 4, 2, 1), and (F1, F2, F3, F4, F5) = (3, 2, 3, 3, 4). If the jobs are partitioned into three batches {1, 2}, {3}, {4, 5}, then the output times (O1, O2, O3, O4, O5) = (5, 5, 10, 14, 14) and the costs of the jobs are (15, 10, 30, 42, 56), respectively. The total cost for a partitioning is the sum of the costs of all jobs. The total cost for the example partitioning above is 153.
You are to write a program which, given the batch setup time and a sequence of jobs with their processing times and cost factors, computes the minimum possible total cost.
A setup time S is needed to set up the machine for each batch. For each job i, we know its cost factor Fi and the time Ti required to process it. If a batch contains the jobs x, x+1,... , x+k, and starts at time t, then the output time of every job in that batch is t + S + (Tx + Tx+1 + ... + Tx+k). Note that the machine outputs the results of all jobs in a batch at the same time. If the output time of job i is Oi, its cost is Oi * Fi. For example, assume that there are 5 jobs, the setup time S = 1, (T1, T2, T3, T4, T5) = (1, 3, 4, 2, 1), and (F1, F2, F3, F4, F5) = (3, 2, 3, 3, 4). If the jobs are partitioned into three batches {1, 2}, {3}, {4, 5}, then the output times (O1, O2, O3, O4, O5) = (5, 5, 10, 14, 14) and the costs of the jobs are (15, 10, 30, 42, 56), respectively. The total cost for a partitioning is the sum of the costs of all jobs. The total cost for the example partitioning above is 153.
You are to write a program which, given the batch setup time and a sequence of jobs with their processing times and cost factors, computes the minimum possible total cost.
Input
Your program reads from standard input. The first line contains the number of jobs N, 1 <= N <= 10000. The second line contains the batch setup time S which is an integer, 0 <= S <= 50. The following N lines contain information about the jobs 1, 2,..., N in
that order as follows. First on each of these lines is an integer Ti, 1 <= Ti <= 100, the processing time of the job. Following that, there is an integer Fi, 1 <= Fi <= 100, the cost factor of the job.
Output
Your program writes to standard output. The output contains one line, which contains one integer: the minimum possible total cost.
Sample Input
5 1 1 3 3 2 4 3 2 3 1 4
Sample Output
153
/**
很多東西不是我自己的思路就不在自己寫介紹了
思路:http://blog.csdn.net/iaccepted/article/details/6699691
*/
#include <stdio.h>
#include <string.h>
#include <algorithm>
#include <iostream>
using namespace std;
const int N=12005;
int dp[N],L[N],st[N],sf[N];
int n,s;
int main()
{
while(~scanf("%d%d",&n,&s))
{
for(int i=1;i<=n;i++)
scanf("%d%d",&st[i],&sf[i]);
dp[n+1]=st[n+1]=sf[n+1]=0;
for(int i=n;i>=1;i--)
st[i]+=st[i+1],sf[i]+=sf[i+1];
int a=0,b=0;
L[b]=n+1;
for(int i=n;i>=1;i--)
{
while(a<b && dp[L[a+1]]-dp[L[a]]<=(st[L[a+1]]-st[L[a]])*sf[i])
a++;
dp[i]=dp[L[a]]+(st[i]-st[L[a]]+s)*sf[i];
while(a<b&&(dp[i]-dp[L[b]])*(st[L[b]]-st[L[b-1]])<=(st[i]-st[L[b]])*(dp[L[b]]-dp[L[b-1]]))
b--;
L[++b]=i;
}
printf("%d\n",dp[1]);
}
return 0;
}
相關文章
- 【DP】斜率優化初步優化
- 斜率優化DP總結優化
- 斜率優化(凸包優化)DP問題acm優化ACM
- 斜率最佳化dp
- 斜率最佳化 DP
- hdu 3507 斜率優化DP入門題優化
- 淺談斜率最佳化DP
- bzoj3156: 防禦準備(斜率優化+Dp)優化
- 洛谷P2365/5785 任務安排 題解 斜率優化DP優化
- POJ3744 Scout YYF I (概率DP + 矩陣優化)矩陣優化
- BZOJ 1597 [Usaco2008 Mar]土地購買:斜率優化dp優化
- 斜率優化動態規劃優化動態規劃
- 斜率優化學習筆記優化筆記
- BZOJ 1010 [HNOI2008]玩具裝箱toy:斜率優化dp優化
- BZOJ 1096 [ZJOI2007]倉庫建設:斜率優化dp優化
- bzoj1911: [Apio2010]特別行動隊(斜率優化+Dp)API優化
- BZOJ 1492 [NOI2007]貨幣兌換Cash:斜率優化dp + cdq分治優化
- bzoj1597: [Usaco2008 Mar]土地購買(斜率優化+Dp+單調佇列)優化佇列
- 洛谷P4027 [NOI2007]貨幣兌換(dp 斜率優化 cdq 二分)優化
- POJ1745Divisibility(dp)
- POJ2955 Brackets (區間DP)Racket
- POJ 2486 Apple Tree(樹形dp)APP
- POJ 1925 Spiderman(線性dp)IDE
- POJ 3744 概率dp+矩陣矩陣
- 斜率最佳化(李超樹)
- 斜率最佳化筆記筆記
- 用多項式的逆優化dp總結優化
- 【dp+離散化+線段樹優化】Paint優化AI
- POJ1160 Post Office[序列DP]
- 【dp】POJ 1015 Jury CompromisePromise
- POJ 3249-Test for Job(拓撲排序&&DP)排序
- POJ 3107 Godfather(樹形dp)Go
- POJ 3017 單調佇列dp佇列
- POJ 3691 DNA repair (AC自動機 + dp)AI
- 四邊形不等式優化DP優化
- POJ 1141 Brackets Sequence(記錄路徑的dp)Racket
- 【樹形dp】poj 1947 Rebuilding RoadsRebuild
- POJ 1664 放蘋果 (基礎組合dp)蘋果